<script>
	let baseHost = "http://localhost:8080"
	let basePath = "atlantis"
	let baseUrl = baseHost + "/" + basePath

	// let promise = getMe();
	let promise = '';

	// TODO: figure out how to loop through the results
	async function getMe() {
		let url = baseUrl + "/users/me";
		console.log(url);
		console.log("cookie: '" + document.cookie + "'");

		const response = await fetch(url, { credentials: "include" });
		console.log(response);
		const body = await response.json();
		console.log(body)

		if (response.ok) {
			// TODO: figure out how to loop through the results in the html
			console.log(body.data)
			// return JSON.stringify(body.data);
			// return JSON.stringify(body.data.email);
			return body.data.first_name + " " + body.data.last_name + " <" + body.data.email + ">";
		} else {
			if (body.error) {
				if (body.error.code == 3) {
					throw new Error("Please log in or register.");
				} else {
					throw new Error(body.error.message + " [" + body.error.code + "]");
				}
			} else {
				throw new Error("An unknown error occurred.");
			}
		}
	}

	function handleMe() {
		promise = getMe();
	}
</script>

<button on:click={handleMe}>
	get me
</button>

{#await promise}
	<p>...waiting</p>
{:then result}
	<p>{result}</p>
{:catch error}
	<p style="color: red">Problem while fetching current user: {error.message}</p>
{/await}
